"""
$Id: note.py 28567 2006-08-02 20:11:19Z rmasse $
$URL: svn+ssh://svn.mems-exchange.org/repos/trunk/dulcinea/lib/note.py $
"""
from datetime import datetime
from dulcinea.attachable import Attachable
from dulcinea.common import get_connection, get_user
from durus.btree import BTree, BNode
from durus.persistent import Persistent
from qp.lib.spec import specify, string, sequence, add_getters_and_setters, init
from qp.pub.user import User

def get_note_mapping():
    return get_connection().get_root().get('note_mapping')

class Note(Persistent, Attachable):

    text_is = (string, None)
    timestamp_is = (datetime, None)
    user_is = (User, None)

    def __init__(self, text=None):
        Attachable.__init__(self)
        init(self, text=text)

    def set_timestamp(self, value=None):
        specify(self, timestamp=value or datetime.now())

    def set_user(self, user=None):
        specify(self, user=user or get_user())

    def is_empty(self):
        return not bool(self.text or self.get_attachments())

add_getters_and_setters(Note)

class Notable:

    note_is = (Note, None)

    def __init__(self, note=None):
        self.set_note(note)

add_getters_and_setters(Notable)


class NoteMapping(BTree):

    root_is = sequence((string, Note), BNode)
