#!/usr/bin/env python

"""$URL: svn+ssh://svn.mems-exchange.org/repos/trunk/dulcinea/setup.py $
$Id: setup.py 28588 2006-08-15 17:11:08Z dbinger $

Setup script for Dulcinea
"""

from distutils import core
from distutils.extension import Extension
unused = Extension # for import checker.  Extension import is for side effect.
from quixote.ptl.qx_distutils import qx_build_py
from lib.__init__ import __version__
import re, sys

if 'sdist' in sys.argv:
    # Make sure that version numbers have all been updated.
    PAT = re.compile(r'\b%s\b' % re.escape(__version__))
    assert len(PAT.findall(open("LICENSE.txt").read())) == 12, __version__
    assert PAT.search(open("CHANGES.txt").readline()), __version__
    assert len(PAT.findall(open("README.txt").read())) == 0, __version__

    # Make sure that copyright statements are current.
    from datetime import datetime
    year = datetime.now().year
    copyright = "Copyright (c) Corporation for National Research Initiatives %s" % year
    assert open("README.txt").read().count(copyright) == 1

kw = {'name': "Dulcinea",
      'version': __version__,
      'description': ("A package of modules useful for developing "
                      "Quixote/Durus applications."),
      'author': "CNRI",
      'author_email': "quixote@mems-exchange.org",
      'url': "http://www.mems-exchange.org/software/dulcinea/",
      'license': "see LICENSE.txt",

      'package_dir': {'dulcinea':'lib'},
      'packages': ['dulcinea',
                   'dulcinea.ui',
                   'dulcinea.uiqp',
                   'dulcinea.ui.lib',
                   'dulcinea.ui.form2',
                   'dulcinea.ui.user'],
      'scripts': ['bin/start-scgi.py',
                  'bin/opendb',
                  'bin/check_durus.py',
                  'bin/site',
                  'bin/expire_session.py',
                  'bin/start-durus.py',
                  'bin/start-apache.py'],
      'cmdclass': {'build_py': qx_build_py},
     }

# If we're running Python 2.3, add extra information
if hasattr(core, 'setup_keywords'):
    if 'classifiers' in core.setup_keywords:
        kw['classifiers'] = ['Development Status :: 3 - Alpha',
          'Intended Audience :: Developers',
          'Operating System :: Unix',
          'Topic :: Software Development :: Libraries',
          ]
    if 'download_url' in core.setup_keywords:
        kw['download_url'] = ('http://www.mems-exchange.org/software/files'
                              '/dulcinea/Dulcinea-%s.tar.gz' % kw['version'])

core.setup(**kw)
